# Class: ImageWMS

## ol.source.ImageWMS

Source for WMS servers providing single, untiled images.

#### new ol.source.ImageWMS(opt_options) experimental

src/ol/source/imagewmssource.js, line 28

  Name | Type | Description
  --- | --- | ---
  `options` | optional Options.
  Name | Type | Description
  --- | --- | ---
  `attributions` | Array.<ol.Attribution> | undefined | optional Attributions.
  `crossOrigin` | null | string | undefined | optional crossOrigin setting for image requests.
  `extent` | ol.Extent | undefined | optional Extent.
  `hidpi` | boolean | undefined | optional Use the `ol.Map#pixelRatio` value when requesting the image from the remote server. Default is `true`.
  `serverType` | ol.source.wms.ServerType | string | undefined | optional The type of the remote WMS server: `mapserver`, `geoserver` or `qgis`. Only needed if `hidpi` is `true`. Default is `undefined`.
  `logo` | string | undefined | optional Logo.
  `params` | Object.<string, *> | WMS request parameters. At least a `LAYERS` param is required. `STYLES` is `''` by default. `VERSION` is `1.3.0` by default. `WIDTH`, `HEIGHT`, `BBOX` and `CRS` (`SRS` for WMS version < 1.3.0) will be set dynamically.
  `projection` | ol.proj.ProjectionLike | Projection.
  `ratio` | number | undefined | optional Ratio. `1` means image requests are the size of the map viewport, `2` means twice the size of the map viewport, and so on. Default is `1.5`.
  `resolutions` | Array.<number> | undefined | optional Resolutions. If specified, requests will be made for these resolutions only.
  `url` | string | undefined | optional WMS service URL.

  ##### Fires:

  - `change` experimental - Triggered when the state of the source changes.

### Extends

- ol.source.Image

### Methods

#### dispatchChangeEvent() inherited experimental

src/ol/observable.js, line 41

  Dispatches a `change` event.

  ##### Fires:

  - `change` experimental

#### getGetFeatureInfoUrl(coordinate, resolution, projection, params){string|undefined} experimental

src/ol/source/imagewmssource.js, line 133

  Return the GetFeatureInfo URL for the passed coordinate, resolution, and projection. Return `undefined` if the GetFeatureInfo URL cannot be constructed.

  Name | Type | Description
  --- | --- | ---
  `coordinate` | ol.Coordinate | Coordinate.
  `resolution` | number | Resolution.
  `projection` | ol.proj.Projection | Projection.
  `params` | Object | GetFeatureInfo params. `INFO_FORMAT` at least should be provided. If `QUERY_LAYERS` is not provided then the layers specified in the `LAYERS` parameter will be used. `VERSION` should not be specified here.

  ##### Returns:

  GetFeatureInfo URL.

#### getParams(){Object} experimental

src/ol/source/imagewmssource.js, line 183

  Get the user-provided params, i.e. those passed to the constructor through the "params" option, and possibly updated using the updateParams method.

  ##### Returns:

  Params.

#### getState(){ol.source.State} inherited experimental

src/ol/source/source.js, line 142

  ##### Returns:

  State.

#### getUrl(){string|undefined} experimental

src/ol/source/imagewmssource.js, line 326

  Return the URL used for this WMS source.

  ##### Returns:

  URL.

#### on(type, listener, opt_this){goog.events.Key} inherited experimental

src/ol/observable.js, line 63

  Listen for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

  ##### Returns:

  Unique key for the listener.

#### once(type, listener, opt_this){goog.events.Key} inherited experimental

src/ol/observable.js, line 76

  Listen once for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

  ##### Returns:

  Unique key for the listener.

#### setUrl(url) experimental

src/ol/source/imagewmssource.js, line 335

  Name | Type | Description
  --- | --- | ---
  `url` | string | undefined | optional URL.

#### un(type, listener, opt_this) inherited experimental

src/ol/observable.js, line 88

  Unlisten for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

#### unByKey(key) inherited experimental

src/ol/observable.js, line 98

  Removes an event listener using the key returned by `on()` or `once()`.

  Name | Type | Description
  --- | --- | ---
  `key` | goog.events.Key | Key.

#### updateParams(params) experimental

src/ol/source/imagewmssource.js, line 349

  Update the user-provided params.

  Name | Type | Description
  --- | --- | ---
  `params` | Object | Params.